/*********************************************************
º	Project Details							
**********************************************************

IQS5xx i2c MASTER example code

Compatible with IQS5xx version: 40_0_55

Azoteq

--------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------
*/


#include "includes.h"

	unsigned char NoOfFingers;
	unsigned char XYInfoByte;
	unsigned char prevXYInfoByte;
	
	IQS5xx_TypeDef IQS5xx[5];
	unsigned int SnapStatus[TOTALTXS_VAL<<1]; 
	

/*  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
						--- IQS5xx_Settings() ---
	Description:	Sends commands to set registers of the IQS5xx via the comms terminal.
				This set of values brings the touch pad to a general working condition,
				The values used in this routine are obtained from the IQS5xx_Init.h file.
				This file can be modified manually, or created by the IQS5xx PC GUI software.
				
	Please Note:  Any settings groups that  kept the default values, can be removed from the setup procedure.
	Also the Active Channels only need to be modified if a specific channel/s within the selected Total or Trackpad
	areas are not required, otherwise these can be left default no matter what the Total/Trackpad settings are.
¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡
*/
void IQS5xx_Settings(void)
{
	unsigned char data_buffer[30];
	
	CommsIQS5xx_start();							// check comms by confirming Version information	
	CommsIQS5xx_Read(VERSION_INFO, &data_buffer, 5);	
	CommsIQS5xx_stop();
	
	if ( (((unsigned int)data_buffer[0]<<8 + (unsigned int)data_buffer[1]) != PRODUCT_NUMBER) || 
		(((unsigned int)data_buffer[2]<<8 + (unsigned int)data_buffer[3]) != PROJECT_NUMBER) || 
		(data_buffer[4] != VERSION_NUMBER) )		// These values must be updated in the IQS5xx_Init.h file
	{
	//	Handle the comms error here!
	}
	
// ACKNOWLEDGE THE RESET INDICATION FLAG
	data_buffer[0] = ACK_RESET;						// Set ACK_RESET flag, which clears SHOW_RESET in XYInfoByte
	CommsIQS5xx_start();
	CommsIQS5xx_Write(CONTROL_SETTINGS, &data_buffer[0], 1); 
	CommsIQS5xx_stop();								// Now the bit is clear, and if ever SHOW_RESET is set.. 
													// ..an unexpected reset can be handled	
// -----------------------------------------------------	
// FIRSTLY SETUP THE CHANNELS USED:
	
	// ChannelSetup Data:
	data_buffer[0] = TOTALRXS_VAL;					// TotalRx
	data_buffer[1] = TOTALTXS_VAL;					// TotalTx
	data_buffer[2] = TRACKPADRXS_VAL;				// TrackPadRx
	data_buffer[3] = TRACKPADTXS_VAL;				// TrackPadTx
	data_buffer[4] = PMSETUP0_VAL;					// PMSetup register
	data_buffer[5] = TXHIGH_VAL;        
	data_buffer[6] = TXLOW_VAL;						// Which Tx's are used for the ProxMode channel (projected only)
	
	CommsIQS5xx_start();							
	CommsIQS5xx_Write(CHANNEL_SETUP, &data_buffer[0], 7);
	CommsIQS5xx_stop();

// -----------------------------------------------------	
// CONFIGURE THE THRESHOLDS:	

	// Threshold settings data
	data_buffer[0] = PROXTHRESHOLD_VAL;				// Prox Threshold
	data_buffer[1] = TOUCHMULTIPLIER_VAL;			// Touch Multiplier
	data_buffer[2] = TOUCHSHIFTER_VAL;				// Touch Shifter
	data_buffer[3] = PMPROXTHRESHOLD_VAL;			// PM Prox Threshold
	data_buffer[4] = (unsigned char)(SNAPTHRESHOLD_VAL>>8);	// Snap threshold
	data_buffer[5] = (unsigned char)SNAPTHRESHOLD_VAL;		// Snap threshold
	data_buffer[6] = PROXTHRESHOLD2_VAL;		// Non-trackpad channels prox threshold
	data_buffer[7] = TOUCHMULTIPLIER2_VAL;			// Non-trackpad channels Touch Multiplier
	data_buffer[8] = TOUCHSHIFTER2_VAL;				// Non-trackpad channels Touch Shifter
	
	CommsIQS5xx_start();							
	CommsIQS5xx_Write(THRESHOLD_SETTINGS, &data_buffer[0], 9); // send thresholds
	CommsIQS5xx_stop();
	
// -----------------------------------------------------	
// SETUP THE ATI PARAMETERS FOR NORMAL MODE, AND EXECUTE AUTO-ATI ALGORITHM;
	
	// ATI Settings Data:
	data_buffer[0] = (unsigned char)(ATITARGET_VAL>>8);
	data_buffer[1] = (unsigned char)ATITARGET_VAL;		// ATI Target
	data_buffer[2] = ATIC_VAL;							// ATI C 
	data_buffer[3] = (unsigned char)(ATITARGET2_VAL>>8);      
	data_buffer[4] = (unsigned char)ATITARGET2_VAL;		// Non-trackpad channels ATI Target
	data_buffer[5] = ATIC2_VAL;							// Non-trackpad channels ATI C 
	
	CommsIQS5xx_start();
	CommsIQS5xx_Write(ATI_SETTINGS, &data_buffer[0], 6); // Write the ATI Parameters
	data_buffer[0] = AUTO_ATI;							 // Set Auto_ATI, with Mode set to Normal Mode.
	CommsIQS5xx_repeat_start();
	CommsIQS5xx_Write(CONTROL_SETTINGS, &data_buffer[0], 1); 
	CommsIQS5xx_stop();									 // Now IQS5xx will permform the Auto-ATI algorithm
	
// -----------------------------------------------------	
// SETUP THE FILTER PARAMETERS;

	// Filter Settings Data:
	data_buffer[0] = FILTERSETTINGS0_VAL;				// Numerous filter settings
	data_buffer[1] = TOUCHDAMPING_VAL;					// XY touch point filtering parameter
	data_buffer[2] = HOVERDAMPING_VAL;					// XY hover point filtering parameter
	data_buffer[3] = PMCOUNTDAMPING_VAL;      			// ProxMode count value filter parameter (full-speed)
	data_buffer[4] = LPPMCOUNTDAMPING_VAL;				// ProxMode count value filter parameter (Low Power)
	data_buffer[5] = NMCOUNTDAMPING_VAL;				// Normal Mode count value filter parameter
	
	CommsIQS5xx_start();							
	CommsIQS5xx_Write(FILTER_SETTINGS, &data_buffer[0], 6);
	CommsIQS5xx_stop();

// -----------------------------------------------------	
// SETUP THE TIMING PARAMETERS;

	// Timing Settings Data:
	data_buffer[0] = RESEEDTIME_VAL;					// LTA reseed timer
	data_buffer[1] = COMMSTIMEOUT_VAL;					// Inactive i2c timeout value
	data_buffer[2] = MODETIME_VAL;						// Mode timer value (Switching between modes time)
	data_buffer[3] = LPTIME_VAL;						// Low power time added in low-power state
	data_buffer[4] = SLEEPTIME_VAL;						// Sleep time permanently added
	
	CommsIQS5xx_start();							
	CommsIQS5xx_Write(TIMING_SETTINGS, &data_buffer[0], 5);
	CommsIQS5xx_stop();
		
// -----------------------------------------------------	
// SETUP THE HARDWARE PARAMETERS;

	// Hardware Config Settings Data:
	data_buffer[0] = PROXSETTINGS0_VAL;					
	data_buffer[1] = PROXSETTINGS1_VAL;					
	data_buffer[2] = PROXSETTINGS2_VAL;					
	data_buffer[3] = PROXSETTINGS3_VAL;					
	
	CommsIQS5xx_start();							
	CommsIQS5xx_Write(HW_CONFIG_SETTINGS, &data_buffer[0], 4);
	CommsIQS5xx_stop();
	
// -----------------------------------------------------	
// SETUP THE ACTIVE CHANNELS

	// Active Channels Data:
	data_buffer[0] = (unsigned char)(ACTIVECHANNELS0_VAL>>8);
	data_buffer[1] = (unsigned char)ACTIVECHANNELS0_VAL;
	data_buffer[2] = (unsigned char)(ACTIVECHANNELS1_VAL>>8);
	data_buffer[3] = (unsigned char)ACTIVECHANNELS1_VAL;
	data_buffer[4] = (unsigned char)(ACTIVECHANNELS2_VAL>>8);
	data_buffer[5] = (unsigned char)ACTIVECHANNELS2_VAL;
	data_buffer[6] = (unsigned char)(ACTIVECHANNELS3_VAL>>8);
	data_buffer[7] = (unsigned char)ACTIVECHANNELS3_VAL;
	data_buffer[8] = (unsigned char)(ACTIVECHANNELS4_VAL>>8);
	data_buffer[9] = (unsigned char)ACTIVECHANNELS4_VAL;
	data_buffer[10] = (unsigned char)(ACTIVECHANNELS5_VAL>>8);
	data_buffer[11] = (unsigned char)ACTIVECHANNELS5_VAL;
	data_buffer[12] = (unsigned char)(ACTIVECHANNELS6_VAL>>8);
	data_buffer[13] = (unsigned char)ACTIVECHANNELS6_VAL;
	data_buffer[14] = (unsigned char)(ACTIVECHANNELS7_VAL>>8);
	data_buffer[15] = (unsigned char)ACTIVECHANNELS7_VAL;
	data_buffer[16] = (unsigned char)(ACTIVECHANNELS8_VAL>>8);
	data_buffer[17] = (unsigned char)ACTIVECHANNELS8_VAL;
	data_buffer[18] = (unsigned char)(ACTIVECHANNELS9_VAL>>8);
	data_buffer[19] = (unsigned char)ACTIVECHANNELS9_VAL;
	data_buffer[20] = (unsigned char)(ACTIVECHANNELS10_VAL>>8);
	data_buffer[21] = (unsigned char)ACTIVECHANNELS10_VAL;
	data_buffer[22] = (unsigned char)(ACTIVECHANNELS11_VAL>>8);
	data_buffer[23] = (unsigned char)ACTIVECHANNELS11_VAL;
	data_buffer[24] = (unsigned char)(ACTIVECHANNELS12_VAL>>8);
	data_buffer[25] = (unsigned char)ACTIVECHANNELS12_VAL;
	data_buffer[26] = (unsigned char)(ACTIVECHANNELS13_VAL>>8);
	data_buffer[27] = (unsigned char)ACTIVECHANNELS13_VAL;
	data_buffer[28] = (unsigned char)(ACTIVECHANNELS14_VAL>>8);
	data_buffer[29] = (unsigned char)ACTIVECHANNELS14_VAL;            
	
	CommsIQS5xx_start();							
	CommsIQS5xx_Write(ACTIVE_CHANNELS, &data_buffer[0], 30);
	CommsIQS5xx_stop();
	
// -----------------------------------------------------	
// SETUP THE DEBOUNCE SETTINGS;

	// DebounceSettings Data:
	data_buffer[0] = PROXDB_VAL;						// Prox Debounce values			
	data_buffer[1] = TOUCHSNAPDB_VAL;					// Touch and Snap debounce values				
	
	CommsIQS5xx_start();							
	CommsIQS5xx_Write(DB_SETTINGS, &data_buffer[0], 2);
	CommsIQS5xx_stop();	
	
// -----------------------------------------------------	
// SETUP THE ATI PARAMETERS FOR PROX MODE, AND EXECUTE AUTO-ATI ALGORITHM
	
	// First change the mode to ProxMode:
	data_buffer[0] = MODE_SELECT;						// Set Mode bit to ProxMode
	CommsIQS5xx_start();
	CommsIQS5xx_Write(CONTROL_SETTINGS, &data_buffer[0], 1); 
	CommsIQS5xx_stop();									// now next cycle will be in ProxMode
	
	// ProxMode ATI Settings Data:
	data_buffer[0] = (unsigned char)(PMATITARGET_VAL>>8);
	data_buffer[1] = (unsigned char)PMATITARGET_VAL;	// PM ATI Target
	data_buffer[2] = PMATIC_VAL;						// PM ATI C
	
	CommsIQS5xx_start();
	CommsIQS5xx_Write(PM_ATI_SETTINGS, &data_buffer[0], 3); // Write the ATI Parameters
	data_buffer[0] = MODE_SELECT | AUTO_ATI;				// Keep ProxMode selected, and enable auto-ati
	CommsIQS5xx_repeat_start();
	CommsIQS5xx_Write(CONTROL_SETTINGS, &data_buffer[0], 1);	
	CommsIQS5xx_stop();										// go and perform PM Auto-ATI Routine

// -----------------------------------------------------	
// NOW FINALLY SETUP THE LOW-POWER, SLEEP, SYSTEM MODE AND EVENT SETTINGS	

	// Control Settings Data:
	data_buffer[0] = CONTROLSETTINGS0_VAL;					
	data_buffer[1] = CONTROLSETTINGS1_VAL;					
	CommsIQS5xx_start();
	CommsIQS5xx_Write(CONTROL_SETTINGS, &data_buffer[0], 2); 
	CommsIQS5xx_stop();
	
// ---- Setup Complete -------
}


/*  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
							---    IQS5xx_Refresh_Data()    ---
	Description:	Obtains updated data from the IQS5xx.   The data is then read to the struct
				containing the IQS5xx data. 
				After reading the relevant data, the i2c STOP condition ends the communication window,
				this means that the IQS5xx will continue with sensing, and return when new data is available
¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡
*/
void IQS5xx_Refresh_Data(void)
{
	unsigned char data_buffer[37], i, j;
//===========================================

	// Read the XY data, but only read as many XY co-ordinates as shown in the XYInfoByte:
	i = 0;
	
	CommsIQS5xx_start();
	data_buffer[i++] = CommsIQS5xx_Read_First_Byte(XY_DATA);	// Read first byte (XYInfo)	
	
	//process XYInfoBYte data:
	if ((XYInfoByte & SHOW_RESET) != 0)						// check for an unexpected reset.
	{
		data_buffer[i] = CommsIQS5xx_Read_Next_Done();		// end the read in progress
		CommsIQS5xx_stop();
		// IQS5xx must be configured with application specific settings, since after reset all will return to default
		// ....... add code here .......
	}
	
	prevXYInfoByte = XYInfoByte;
	XYInfoByte = data_buffer[0];
	NoOfFingers = XYInfoByte & 0x0F;
	
	if (NoOfFingers > 0)
	{
		for (j = 0; j < ((NoOfFingers*7)-1); j++)
		{
			data_buffer[i++] = CommsIQS5xx_Read_Next_Cont();
		}
		data_buffer[i++] = CommsIQS5xx_Read_Next_Done();	// last read must have a NACK
	}
	else
		data_buffer[i] = CommsIQS5xx_Read_Next_Done();		// MUST read another because must.. 
															// ..know about NACK beforehand.
	
// sort the received XY data in structure	
	for (i = 0; i < NoOfFingers; i++)
	{
		IQS5xx[i].ID = data_buffer[(i*7)+1];
			   
		IQS5xx[i].Xpos = (int)(data_buffer[(i*7)+2])<<8;
		IQS5xx[i].Xpos |= data_buffer[(i*7)+3];
			   
		IQS5xx[i].Ypos = (int)(data_buffer[(i*7)+4])<<8;
		IQS5xx[i].Ypos |= data_buffer[(i*7)+5];
			   
		IQS5xx[i].TouchStrength = (int)(data_buffer[(i*7)+6])<<8;
		IQS5xx[i].TouchStrength |= data_buffer[(i*7)+7];
	}
	
	if ((XYInfoByte & SNAP_OUTPUT) != 0)					// if there are active snap outputs
	{
		CommsIQS5xx_repeat_start();
		CommsIQS5xx_Read(SNAP_STATUS, &data_buffer[0], (TOTALTXS_VAL<<1)); // 2 bytes per Tx for snap status
		
		// sort the received SNAP data
		for (i = 0; i < TOTALTXS_VAL; i++)
			SnapStatus[i] = (((unsigned int)data_buffer[i<<1])<<8) + ((unsigned int)data_buffer[(i<<1) + 1]); // add the upper and lower bytes to get the full word
	}
	else
	{
		for (i = 0; i < TOTALTXS_VAL; i++)
			SnapStatus[i] = 0x0000; 						// no snaps, so set registers all to zero
	}
		
	CommsIQS5xx_stop();
}


/*  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
						---   CommsIQS5xx_Write()   ---
	Description:	Writes data to the IQS5xx
				
	Input:		write_addr - This is the IQS5xx ADDRESS-COMMAND
				data - Pointer to an array of chars, which contain the data to write to the IQS5xx
				NoOfBytes - The number of bytes to write to the IQS5xx
				
	Limitations:		This function must be preceded by one of the following function calls:
				CommsIQS5xx_start(), CommsIQS5xx_repeat_start(), 
				
				This function must be followed by one of the following function calls:
				CommsIQS5xx_repeat_start(), CommsIQS5xx_stop
¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡
*/
void CommsIQS5xx_Write(unsigned char write_addr, unsigned char *data, unsigned char NoOfBytes)
{
	unsigned char i;
// ==================================

	CommsIQS5xx_send((IQS5xx_ADDR << 1) + 0x00);			// device address + write		
	CommsIQS5xx_send(write_addr);							// IQS5xx address-command
	for (i = 0 ; i < NoOfBytes ; i++) 
		CommsIQS5xx_send(data[i]);
}

/*  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
						----    CommsIQS5xx_Read()    ----
	Description:	Reads data from the IQS5xx
				
	Input:		read_addr - This is the IQS5xx ADDRESS-COMMAND
				data - Pointer to an array of chars, where the data READ from the IQS5xx is stored
				NoOfBytes - The number of bytes to read from the IQS5xx
				
	Limitations:		This function must be preceded by one of the following function calls:
				CommsIQS5xx_start(), CommsIQS5xx_repeat_start(), 
				
				This function must be followed by one of the following function calls:
				CommsIQS5xx_repeat_start(), CommsIQS5xx_stop
¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡
*/
void CommsIQS5xx_Read(unsigned char read_addr, unsigned char *data, unsigned char NoOfBytes)
{
	unsigned char i;
// ==================================

	CommsIQS5xx_send((IQS5xx_ADDR << 1) + 0x00);			// device address + write
	CommsIQS5xx_send(read_addr);							// IQS5xx address-command
	CommsIQS5xx_repeat_start();
	CommsIQS5xx_send((IQS5xx_ADDR << 1) + 0x01);			// device address + read
	
	if (NoOfBytes > 1)
	{
		for (i = 0; i < NoOfBytes - 1; i++)
			data[i] = CommsIQS5xx_read_ack();				// all bytes except last must be followed by an ACK
	}
	
	data[NoOfBytes-1] = CommsIQS5xx_read_nack();			// last byte read must be followed by a NACK
}

/*  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
						----    CommsIQS5xx_Read_First_Byte()    ----
	Description:	Returns the first byte read from the Address-command specified.

	Input:		start_addr - This is the IQS5xx ADDRESS-COMMAND
				
	Limitations:		This function must be preceded by one of the following function calls:
				CommsIQS5xx_start(), CommsIQS5xx_repeat_start().
				
				This function must be followed by one of the following function calls:
				CommsIQS5xx_Read_Next_Cont(), CommsIQS5xx_Read_Next_Done().	
¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡
*/
unsigned char CommsIQS5xx_Read_First_Byte(unsigned char start_addr)
{
	CommsIQS5xx_send((IQS5xx_ADDR << 1) + 0x00);
	CommsIQS5xx_send(start_addr);
	CommsIQS5xx_repeat_start();
	CommsIQS5xx_send((IQS5xx_ADDR << 1) + 0x01);
	return CommsIQS5xx_read_ack();
}


/*  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
						----    CommsIQS5xx_Read_Next_Cont()    ----
	Description:	This function returns the next byte from the IQS5xx (Address-command already specified in
				CommsIQS5xx_Read_First_Byte() function.  This function is used for a byte read that is not
				the last in the sequence.  Thus another read must still be done.
	
	Limitations:		This function must be preceded by one of the following function calls:
				CommsIQS5xx_Read_First_Byte(), CommsIQS5xx_Read_Next_Cont().
				
				This function must be followed by one of the following function calls:
				CommsIQS5xx_Read_Next_Cont(), CommsIQS5xx_Read_Next_Done().	
¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡
*/
unsigned char CommsIQS5xx_Read_Next_Cont(void)
{
	return CommsIQS5xx_read_ack();
}

/*  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
						----    CommsIQS5xx_Read_Next_Done()    ----
	Description:	This function returns the next byte from the IQS5xx.  Address-command already specified in
				CommsIQS5xx_Read_First_Byte() function.  This function is the last read for the specific
				address-command.
	
	Limitations:		This function must be preceded by one of the following function calls:
				CommsIQS5xx_Read_First_Byte(), CommsIQS5xx_Read_Next_Cont().
				
				This function must be followed by one of the following function calls:
				CommsIQS5xx_repeat_start(), CommsIQS5xx_stop
¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡
*/						
unsigned char CommsIQS5xx_Read_Next_Done(void)
{
	return CommsIQS5xx_read_nack();
}

/*  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
						----    CommsIQS5xx_Initiate_Conversion()    ----
	Description:	This function is the quickest way to end a communication window, and allow the 
				IQS5xx to continue with its sensing.
				
¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡¡
*/

void CommsIQS5xx_Initiate_Conversion(void)
{
	CommsIQS5xx_start();
	CommsIQS5xx_send((IQS5xx_ADDR << 1) + 0x00);
	CommsIQS5xx_stop();
}

